unit untProcNavigate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, SynMemo, StdCtrls;

type
  TfrmProcNavigate = class(TForm)
    lstbxProcNavigate: TListBox;
    procedure FormShow(Sender: TObject);
    procedure lstbxProcNavigateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstbxProcNavigateClick(Sender: TObject);
    procedure lstbxProcNavigateDblClick(Sender: TObject);
    procedure lstbxProcNavigateContextPopup(Sender: TObject;
      MousePos: TPoint; var Handled: Boolean);
    procedure lstbxProcNavigateKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure GoToProc(Sender: TObject; AProcName: String);
  public
    { Public declarations }
  end;

procedure ShowProcNavigate;

var
  frmProcNavigate: TfrmProcNavigate;
  xc, yc: Integer; //    
  DetectKeyDown: Boolean;

implementation

uses untMain;

{$R *.DFM}

procedure ShowProcNavigate;
begin
  with TfrmProcNavigate.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmProcNavigate.FormShow(Sender: TObject);
var i: Integer;
begin //    
(*
  with lstbxProcNavigate do
  begin
    Items.Add(' ');
    for i:=1 to frmMain.pgcntrlMain.PageCount-1 do
      Items.Add(frmMain.pgcntrlMain.Pages[i].Caption);
    if frmMain.pgcntrlMain.ActivePageIndex>=0 then
      ItemIndex := frmMain.pgcntrlMain.ActivePageIndex;
  end;
  *)
end;

procedure TfrmProcNavigate.GoToProc(Sender: TObject; AProcName: String);
var i: Integer;
begin
(*
  with frmMain do
  begin
    i := GetPageAtNameProc(AProcName);
    //ShowMessage(PrName+' i='+IntToStr(i));
    if i<0 then i:=0;
    with pgcntrlMain.ActivePage.Controls[0] as TSynMemo do
    begin
      //  
      NormCurAndCol;//(Sender);  //      
      if pgcntrlMain.ActivePage<>pgcntrlMain.Pages[i] then
      begin
        pgcntrlMain.ActivePage := pgcntrlMain.Pages[i]; //   
        NavigatorControl; //  
      end;
    end;
  end;
  *)
end;

procedure TfrmProcNavigate.lstbxProcNavigateKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  DetectKeyDown := True; //  OnClick
  if Key=VK_ESCAPE then // Esc
    ModalResult := mrCancel; //  
  with lstbxProcNavigate do
  begin
    if ItemIndex<0 then ItemIndex := 0;
    if (Key=VK_SPACE) then // Space
        GoToProc(Sender, Items.Strings[ItemIndex]); //  
    if Key=VK_RETURN then // Enter
    begin
      GoToProc(Sender, Items.Strings[ItemIndex]); //  
      ModalResult := mrCancel; //  
    end;
  end;
end;

procedure TfrmProcNavigate.lstbxProcNavigateClick(Sender: TObject);
begin
  if not(DetectKeyDown) then //         
    with lstbxProcNavigate do
      if ItemIndex>=0 then GoToProc(Sender, Items.Strings[ItemIndex]); //  
end;

procedure TfrmProcNavigate.lstbxProcNavigateDblClick(Sender: TObject);
begin
  ModalResult := mrCancel; //  
end;

procedure TfrmProcNavigate.lstbxProcNavigateContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  //SendMessage(lstbxProcNavigate.handle, WM_RBUTTONDBLCLK, 0, 0);
  //SendMessage(lstbxProcNavigate.handle, WM_LBUTTONDOWN, 0, 0);
  //SendMessage(lstbxProcNavigate.handle, WM_LBUTTONUP, 0, 0);
  //Mouse_Event
  //lstbxProcNavigate.Perform(WM_LBUTTONDOWN, 100, 100);
  //lstbxProcNavigate.Perform(WM_LBUTTONUP,100, 100);
  //with lstbxProcNavigate do
    //if ItemIndex>=0 then GoToProc(Sender, Items.Strings[ItemIndex]); //  
end;

procedure TfrmProcNavigate.lstbxProcNavigateKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  DetectKeyDown := False;
end;

end.
