unit MenuPrepare;

interface

uses Menus, Classes, Grids, SysUtils, ComCtrls;

  procedure MenuEventInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; const AFName: string);
  //procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; const AFName: string);
  //function AddNewNode(var Tree: TTreeView; const Section: Boolean; Name, AHint, ASnip: String): TTreeNode;
  function AddNewNode(var Tree: TTreeView; const Section: Boolean; Name: String; Index: Integer): TTreeNode;
  //procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; var ATree: TtreeView; const AFName: string);
  procedure TreeSnippetInitialize(var ATree: TTreeView; const AFName: string);
var
  MnuTek, OldTek: TMenuItem;
  ind: Word;

implementation

uses untMain;

procedure MenuEventInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; const AFName: string);
var
  i, l1: Word;
  tz: string;
  AMnuItem: TMenuItem;
begin //      
  with frmMain do
  begin
    if not FileExists(ASelfPath + AFName) then Exit;
    rcdtTemp.Lines.LoadFromFile(ASelfPath + AFName);
    for i:=0 to rcdtTemp.Lines.Count-1 do
    begin
      tz := rcdtTemp.Lines[i];
      if (tz='') or (Copy(tz, 1, 2)='//') then Continue; //  
      if Copy(tz, 1, 3)='<->' then // 
      begin
        AMnuItem := TMenuItem.Create(APopup);
        APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := '-';
        Continue;
      end;
      if Copy(tz, 1, 3)='<m>' then
      begin
        AMnuItem := TMenuItem.Create(APopup);
        APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := Copy(tz, 4, Length(tz));
        MnuTek := AMnuItem;
      end
      else
      begin
        l1 := Pos('<d>' , tz);
        AMnuItem := TMenuItem.Create(APopup);
        if MnuTek<>nil then MnuTek.Add(AMnuItem)
        else APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := Copy(tz, 1, l1-1);
        AMnuItem.Hint := Copy(tz, l1+3, Length(tz));
        AMnuItem.OnClick := AEvent;
        with grdStandProc do
        begin
          if RowCount<=ind then RowCount:=RowCount+1;
          Cells[0, ind] := IntToStr(ind);
          Cells[1, ind] := AMnuItem.Caption;
          Cells[2, ind] := AMnuItem.Hint;
          ind := ind + 1;
        end;
      end;
    end;
  end;
  MnuTek:=nil;
end;

//function AddNewNode(var Tree: TTreeView; const Section: Boolean; Name, AHint, ASnip: String): TTreeNode;
function AddNewNode(var Tree: TTreeView; const Section: Boolean; Name: String; Index: Integer): TTreeNode;
var DCPtr: ^Integer;
//var DCPtr: PDConstr;
begin //   ;  Section=True,    ,   ,   
  Result := nil;
  New(DCPtr);
  //DCPtr^.Hint := AHint;
  //DCPtr^.Snip := ASnip;
  DCPtr^ := Index;
  with Tree.Items do
    case Section of
      True:   Result := AddObject(Tree.Selected, Name, DCPtr);
      False:  Result := AddChildObject(Tree.Selected, Name, DCPtr);
    end;
end;

//procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; var ATree: TtreeView; const AFName: string);
procedure TreeSnippetInitialize(var ATree: TTreeView; const AFName: string);
var
  i, l1, l2: Word;
  tz: string;
  //AMnuItem: TMenuItem;
  ANode, BNode: TTreeNode;
begin
  ind := 0;
  ANode := nil;
  SetLength(KeyWords, Length(KeyWords)+1);
  with frmMain do
  begin
    if not FileExists(ASelfPath + AFName) then Exit;
    rcdtTemp.Lines.LoadFromFile(ASelfPath + AFName);
    for i:=0 to rcdtTemp.Lines.Count-1 do
    begin
      //SetLength(KeyWords, Length(KeyWords)+1);
      tz := rcdtTemp.Lines[i];
      if (tz='') or (Copy(tz, 1, 2)='//') then Continue; //  
      if Copy(tz, 1, 3)='<->' then // 
      begin
        //AMnuItem := TMenuItem.Create(APopup);
        //APopup.Items.Add(AMnuItem);
        //AMnuItem.Caption := '-';
        AddNewNode(ATree, True, '------------------------------------------------', -1);
        Continue;
      end;
      if Copy(tz, 1, 2)='<m' then  // 
      begin
        if Copy(tz, 1, 3)='<m>' then
        begin
          //AMnuItem := TMenuItem.Create(APopup);
          //APopup.Items.Add(AMnuItem);
          //AMnuItem.Caption := Copy(tz, 4, Length(tz));
          //MnuTek := AMnuItem;

          ANode := AddNewNode(ATree, True, Copy(tz, 4, Length(tz)), -1);
          ANode.Selected := True;
        end;
        if Copy(tz, 1, 4)='<m+>' then
        begin
          //AMnuItem := TMenuItem.Create(APopup);
          //if MnuTek<>nil then MnuTek.Add(AMnuItem)
          //else APopup.Items.Add(AMnuItem);
          //AMnuItem.Caption := Copy(tz, 5, Length(tz));
          //OldTek := MnuTek;
          //MnuTek := AMnuItem;

          BNode := AddNewNode(ATree, False, Copy(tz, 5, Length(tz)), -1);
          BNode.Selected := True;
        end;
        if Copy(tz, 1, 4)='<m->' then
        begin
          //MnuTek := OldTek;
          ANode.Selected := True;
        end;
      end
      else //  
      begin
        l1 := Pos('<d>' , tz);
        l2 := Pos('<s>' , tz);
        //AMnuItem := TMenuItem.Create(APopup);
        //if MnuTek<>nil then MnuTek.Add(AMnuItem)
        //else APopup.Items.Add(AMnuItem);
        //AMnuItem.Caption := Copy(tz, 1, l1-1);
        //AMnuItem.Hint := Copy(tz, l1+3, l2-l1-3);
        //AMnuItem.Tag := ind;
        //AMnuItem.OnClick := AEvent;
       { with AGrid do
        begin
          if RowCount<=ind then RowCount:=RowCount+1;
          Cells[0, ind] := IntToStr(ind);
          Cells[1, ind] := Copy(tz, 1, l1-1); //AMnuItem.Caption;
          Cells[2, ind] := Copy(tz, l1+3, l2-l1-3); //AMnuItem.Hint;
          Cells[3, ind] := Copy(tz, l2+3, Length(tz));  }
          //if Length(KeyWords)<=ind then SetLength(KeyWords, Length(KeyWords)+1);
          KeyWords[Length(KeyWords)-1].Name := Copy(tz, 1, l1-1);          // 
          KeyWords[Length(KeyWords)-1].Hint := Copy(tz, l1+3, l2-l1-3);    // 
          KeyWords[Length(KeyWords)-1].Snip := Copy(tz, l2+3, Length(tz)); // 
          if ANode<>nil then AddNewNode(ATree, False, KeyWords[Length(KeyWords)-1].Name, Length(KeyWords)-1)
          else AddNewNode(ATree, True, KeyWords[Length(KeyWords)-1].Name, Length(KeyWords)-1);
          SetLength(KeyWords, Length(KeyWords)+1);
          //if ANode<>nil then AddNewNode(ATree, False, Cells[1, ind], ind)
          //else AddNewNode(ATree, True, Cells[1, ind], ind);
          //ind := ind + 1;
        {end;   }
      end;
    end;
  end;
end;

(*
//procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; const AFName: string);
procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; var ATree: TtreeView; const AFName: string);
var
  i, l1, l2: Word;
  tz: string;
  AMnuItem: TMenuItem;
  ANode, BNode: TTreeNode;
begin
  ind := 0;
  ANode := nil;
  with frmMain do
  begin
    if not FileExists(ASelfPath + AFName) then Exit;
    rcdtTemp.Lines.LoadFromFile(ASelfPath + AFName);
    for i:=0 to rcdtTemp.Lines.Count-1 do
    begin
      tz := rcdtTemp.Lines[i];
      if (tz='') or (Copy(tz, 1, 2)='//') then Continue; //  
      if Copy(tz, 1, 3)='<->' then // 
      begin
        AMnuItem := TMenuItem.Create(APopup);
        APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := '-';
        AddNewNode(ATree, True, '------------------------------------------------', '', '');
        Continue;
      end;
      if Copy(tz, 1, 2)='<m' then  // 
      begin
        if Copy(tz, 1, 3)='<m>' then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := Copy(tz, 4, Length(tz));
          MnuTek := AMnuItem;

          ANode := AddNewNode(ATree, True, AMnuItem.Caption, '', '');
          ANode.Selected := True;
        end;
        if Copy(tz, 1, 4)='<m+>' then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          if MnuTek<>nil then MnuTek.Add(AMnuItem)
          else APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := Copy(tz, 5, Length(tz));
          OldTek := MnuTek;
          MnuTek := AMnuItem;

          BNode := AddNewNode(ATree, False, AMnuItem.Caption, '', '');
          BNode.Selected := True;
        end;
        if Copy(tz, 1, 4)='<m->' then
        begin
          MnuTek := OldTek;
          ANode.Selected := True;
        end;
      end
      else //  
      begin
        l1 := Pos('<d>' , tz);
        l2 := Pos('<s>' , tz);
        AMnuItem := TMenuItem.Create(APopup);
        if MnuTek<>nil then MnuTek.Add(AMnuItem)
        else APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := Copy(tz, 1, l1-1);
        AMnuItem.Hint := Copy(tz, l1+3, l2-l1-3);
        AMnuItem.Tag := ind;
        AMnuItem.OnClick := AEvent;

        if ANode<>nil then {BNode := }AddNewNode(ATree, False, AMnuItem.Caption, AMnuItem.Hint, Copy(tz, l2+3, Length(tz)))
        else {BNode := }AddNewNode(ATree, True, AMnuItem.Caption, AMnuItem.Hint, Copy(tz, l2+3, Length(tz)));

        with AGrid do
        begin
          if RowCount<=ind then RowCount:=RowCount+1;
          Cells[0, ind] := IntToStr(ind);
          Cells[1, ind] := AMnuItem.Caption;
          Cells[2, ind] := AMnuItem.Hint;
          Cells[3, ind] := Copy(tz, l2+3, Length(tz));
          ind := ind + 1;
        end;
      end;
    end;
  end;
  MnuTek := nil;
end;
*)

{
procedure MenuCmdInitialize(AEvent: TNotifyEvent; var APopup: TPopupMenu; var AGrid: TStringGrid; const AFName: string);
var
  i, l1, l2: Word;
  tz: string;
  AMnuItem: TMenuItem;
begin
  ind := 0;
  with frmMain do
  begin
    rcdtTemp.Lines.LoadFromFile(ASelfPath + AFName);
    for i:=0 to rcdtTemp.Lines.Count-1 do
    begin
      tz := rcdtTemp.Lines[i];
      if (tz='') or (Copy(tz, 1, 2)='//') then Continue; //  
      if Copy(tz, 1, 3)='<->' then // 
      begin
        AMnuItem := TMenuItem.Create(APopup);
        APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := '-';
        Continue;
      end;
      if Copy(tz, 1, 2)='<m' then  // 
      begin
        if Copy(tz, 1, 3)='<m>' then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := Copy(tz, 4, Length(tz));
          MnuTek := AMnuItem;
        end;
        if Copy(tz, 1, 4)='<m+>' then
        begin
          AMnuItem := TMenuItem.Create(APopup);
          if MnuTek<>nil then MnuTek.Add(AMnuItem)
          else APopup.Items.Add(AMnuItem);
          AMnuItem.Caption := Copy(tz, 5, Length(tz));
          OldTek := MnuTek;
          MnuTek := AMnuItem;
        end;
        if Copy(tz, 1, 4)='<m->' then
        begin
          MnuTek := OldTek;
        end;
      end
      else //  
      begin
        l1 := Pos('<d>' , tz);
        l2 := Pos('<s>' , tz);
        AMnuItem := TMenuItem.Create(APopup);
        if MnuTek<>nil then MnuTek.Add(AMnuItem)
        else APopup.Items.Add(AMnuItem);
        AMnuItem.Caption := Copy(tz, 1, l1-1);
        AMnuItem.Hint := Copy(tz, l1+3, l2-l1-3);
        AMnuItem.Tag := ind;
        AMnuItem.OnClick := AEvent;
        with AGrid do
        begin
          if RowCount<=ind then RowCount:=RowCount+1;
          Cells[0, ind] := IntToStr(ind);
          Cells[1, ind] := AMnuItem.Caption;
          Cells[2, ind] := AMnuItem.Hint;
          Cells[3, ind] := Copy(tz, l2+3, Length(tz));
          ind := ind + 1;
        end;
      end;
    end;
  end;
  MnuTek:=nil;
end;
}
{
procedure TreeSnippetInitialize(const AFName: string);
var
  i, l1, l2: Word;
  tz: string;
begin
  ind := 0;
  with frmMain do
  begin
    rcdtTemp.Lines.LoadFromFile(ASelfPath + AFName);
    for i:=0 to rcdtTemp.Lines.Count-1 do
    begin
      tz := rcdtTemp.Lines[i];
      if (tz='') or (Copy(tz, 1, 2)='//') then Continue; //  
      if Copy(tz, 1, 3)='<->' then // 
      begin
        Continue;
      end;
      if Copy(tz, 1, 2)='<m' then  // 
      begin
        if Copy(tz, 1, 3)='<m>' then
        begin //   
          // := Copy(tz, 4, Length(tz));

        end;
        if Copy(tz, 1, 4)='<m+>' then
        begin //  

        end;
        if Copy(tz, 1, 4)='<m->' then
        begin //   

        end;
      end
      else //    
      begin
        l1 := Pos('<d>' , tz);
        l2 := Pos('<s>' , tz);

        // := Copy(tz, 1, l1-1);
        // := Copy(tz, l1+3, l2-l1-3);

      end;
    end;
  end;

end; }

end.
